/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package MatrixSumSolver;

import java.util.Random;
import MatrixSumSolver.fastsumsolver.FastSumSolver;

/**
 *
 * @author Michael
 */
public class Main {

    public static void main(String args[]) {

        // create testmatrixes
        int[][] matrix1 = {
            {1, 2, 3, 5, 8},
            {8, 20, 23, 29, 40},
            {7, 11, 15, 18, 24},
            {23, 27, 30, 38, 40}
        };
        int[][] matrix2 = createRandomMatrix(5, 5, 30);
        int[][] matrix3 = createRandomMatrix(9, 9, 30);
        int[][] matrix4 = createRandomMatrix(30, 30, 100);

        test(matrix1, 72, true);
        test(matrix2, 72, false);
        test(matrix3, 72, false);
        test(matrix4, 100, false);
    }

    /**
     *
     * @param lines
     * @param columns
     * @param maxVal
     * @return
     */
    public static int[][] createRandomMatrix(int lines, int columns, int maxVal) {
        int[][] matrix = new int[lines][columns];
        Random rnd = new Random( System.currentTimeMillis() );

        for(int l=0; l<lines; l++) {
            for(int c=0; c<columns; c++) {
                matrix[l][c] = rnd.nextInt(maxVal);
            }
        }

        return matrix;
    }

    /**
     *
     * @param matrix
     * @return
     */
    public static String matrix2string(int[][] matrix) {
        StringBuilder sb = new StringBuilder();

        for(int l=0; l<matrix.length; l++) {
            sb.append("\t|");
            for(int c=0; c<matrix[l].length; c++) {
                sb.append('\t').append(matrix[l][c]);
            }
            sb.append("\t|\n");
        }

        return sb.toString();
    }

    /**
     *
     * @param matrix
     */
    public static void test(int[][] matrix, int targetSum, boolean printSums) {
        FastSumSolver fastSolver = new FastSumSolver();
        SlowSumSolver slowSolver = new SlowSumSolver();

        System.out.println("\n\n###############################################################################");
        System.out.println("# test                                                                        #");
        System.out.println("###############################################################################");

        if( matrix.length < 10 ) {
            String m = matrix2string(matrix);
            System.out.println("\nmatrix:\n"+m+"\n");
        }

        fastSolver.solve(matrix, targetSum);
        slowSolver.solve(matrix, targetSum, printSums);

    }
}
