/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package MatrixSumSolver;

import java.util.Arrays;

/**
 *
 * @author Michael
 */
public class SlowSumSolver {

    public void solve(int[][] matrix, int targetSum, boolean printSums) {
        long startTime, endTime;

        int[] columnIndices = new int[matrix.length];
        Arrays.fill( columnIndices, 0);

        int count = 0;
        System.out.println("----------------------------------------------------------------------------");
        System.out.println("slow sum solver, matrix size: "+matrix.length+"x"+matrix[0].length+", target sum = "+targetSum);
        startTime = System.currentTimeMillis();

        do {

            int sum = getSum(matrix, columnIndices);

            if( sum == targetSum ) {
                if(printSums) {
                    int checkSum = 0;
                    for(int i=0; i<columnIndices.length; i++) {
                        int v = matrix[i][columnIndices[i]];
                        System.out.print("\t"+v);
                        checkSum += v;
                    }
                    System.out.println("\t= "+checkSum);
                }
                count++;
            }

            incIndices(matrix, columnIndices);

        } while( ! isFinished(matrix, columnIndices) );

        endTime = System.currentTimeMillis();
        System.out.print(count+" solutions found in ");
        System.out.println( ((endTime-startTime)/1000d)+" seconds");
    }

    private int getSum(int[][] matrix, int[] columnIndices) {
        int sum = 0;
        for(int i=0; i<columnIndices.length; i++) {
            sum += matrix[i][columnIndices[i]];
        }
        return sum;
    }

    private void incIndices(int[][] matrix, int[] columnIndices) {
        for(int i=0; i<columnIndices.length; i++) {
            columnIndices[i]++;
            if(columnIndices[i] < matrix[i].length) {
                break;
            }
            columnIndices[i] = 0;
        }
    }

    private boolean isFinished(int[][] matrix, int[] columnIndices) {
        int v = 0;
        for(int i : columnIndices) {
            v |= i;
        }
        return v == 0;
    }
}
