/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package MatrixSumSolver.fastsumsolver;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Michael
 */
public class CombinedEquivalenceClass implements EquivalenceClass {

    class Pair {
        EquivalenceClass e1, e2;
        public Pair(EquivalenceClass e1, EquivalenceClass e2) {
            this.e1 = e1;
            this.e2 = e2;
        }
    }

    private final int value;
    private final List<Pair> list;


    public CombinedEquivalenceClass(int value) {
        this.value = value;
        list = new ArrayList<>();
    }

    @Override
    public int getValue() {
        return value;
    }

    public void add(EquivalenceClass e1, EquivalenceClass e2) {
        list.add( new Pair(e1, e2) );
    }

    @Override
    public long getElementCount() {
        long count = 0;
        for(Pair pair : list) {
            count += pair.e1.getElementCount() * pair.e2.getElementCount();
        }
        return count;
    }
}
